#!/usr/bin/python
# coding: utf-8

# python 2 or 3
#import os
#import virtkey

def main():
    try:
        file = open("/tmp/virtkey.txt","a+")
        file.write('\n Begin \n')
        file.flush()
        #kbd = virtkey.virtkey()
        from evdev import UInput, ecodes as e
        ui = UInput()
    except Exception as e:
        file.write(str(e))
        file.flush()
        file.close()
        exit()

    while True:
        try:
            hidraw = open('/dev/wirelesspen', 'r')
            c = hidraw.read(3)
            if c[2:3]=='N':
                # accepts only KEY_* events by default
                ui.write(e.EV_KEY, e.KEY_PAGEDOWN, 1)  # KEY down
                ui.write(e.EV_KEY, e.KEY_PAGEDOWN, 0)  # KEY up
                ui.syn()
                #kbd.press_keysym(0xff56)
                #kbd.release_keysym(0xff56)
            elif c[2:3]=='K':
                # accepts only KEY_* events by default
                ui.write(e.EV_KEY, e.KEY_PAGEUP, 1)  # KEY down
                ui.write(e.EV_KEY, e.KEY_PAGEUP, 0)  # KEY up
                ui.syn()
                #kbd.press_keysym(0xff55)
                #kbd.release_keysym(0xff55)
        except IOError as ioe:
            file.write('\n /dev/wirelesspen can not read \n')
            file.write(str(ioe))
            file.flush()
            file.close()
            exit()
        except KeyboardInterrupt:
            file.write('\n KeyboardInterrupt \n')
            file.flush()
            file.close()
            exit()
        except Exception as e:
            file.write(str(e) + '\n')
            file.flush()

if __name__ == "__main__":
    #pid = os.fork()
    #if pid != 0:
    #    os._exit(0)
    main()



'''
># apt-get install python-evdev

># nano /etc/udev/rules.d/51-android.rules

ACTION=="add", SUBSYSTEM=="hidraw", ATTRS{idVendor}=="1d57", MODE="0666", SYMLINK+="wirelesspen", RUN+="/bin/systemctl --no-block start wirelesspen.service"
SUBSYSTEM=="misc", KERNEL=="uinput", MODE="0660", GROUP="uinput"

># udevadm control --reload

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
># nano /etc/systemd/system/wirelesspen.service

[Unit]
Description=Wireless Pen

[Service]
Type=simple
ExecStart=/usr/bin/wirelesspen.py

># systemctl daemon-reload

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

sudo udevadm monitor

udevadm info -a -n /dev/hidraw0

udevadm info -a -p /sys/devices/pci0000:00/0000:00:1d.2/usb8/8-2/8-2:1.0/0003:1D57:AC01.000F/hidraw/hidraw0


'''
#============================================================================
'''
#!/usr/bin/python
# coding: utf-8
import os
import struct

fmt = "llHHI"
size = struct.calcsize(fmt)
filename = "/dev/input/event3"

fd = os.open(filename, os.O_RDWR)
while 1:
    op = os.read(fd, size)
    timeval, suseconds, typ, code, value = struct.unpack(fmt, op)
    print typ, code, value

, RUN+="/usr/bin/wirelesspen_relay.sh"
#####sudo /etc/init.d/udev restart
##wirelesspen_relay.sh#####
#!/bin/bash

nohup /usr/bin/wirelesspen.py &
exit 0
###########################
'''
#============================================================================
'''
Bus 008 Device 002: ID 1d57:ac01 Xenta Wireless Receiver (Keyboard and Mouse)

lsusb -s 008:002 -v

Bus 008 Device 002: ID 1d57:ac01 Xenta Wireless Receiver (Keyboard and Mouse)
Device Descriptor:
  bLength                18
  bDescriptorType         1
  bcdUSB               2.00
  bDeviceClass            0 (Defined at Interface level)
  bDeviceSubClass         0 
  bDeviceProtocol         0 
  bMaxPacketSize0         8
  idVendor           0x1d57 Xenta
  idProduct          0xac01 Wireless Receiver (Keyboard and Mouse)
  bcdDevice           11.10
  iManufacturer           1 HID-compliant Mouse
  iProduct                2 HID-compliant Mouse
  iSerial                 0 
  bNumConfigurations      1
  Configuration Descriptor:
    bLength                 9
    bDescriptorType         2
    wTotalLength           34
    bNumInterfaces          1
    bConfigurationValue     1
    iConfiguration          0 
    bmAttributes         0xa0
      (Bus Powered)
      Remote Wakeup
    MaxPower              100mA
    Interface Descriptor:
      bLength                 9
      bDescriptorType         4
      bInterfaceNumber        0
      bAlternateSetting       0
      bNumEndpoints           1
      bInterfaceClass         3 Human Interface Device
      bInterfaceSubClass      1 Boot Interface Subclass
      bInterfaceProtocol      1 Keyboard
      iInterface              0 
        HID Device Descriptor:
          bLength                 9
          bDescriptorType        33
          bcdHID               1.10
          bCountryCode            0 Not supported
          bNumDescriptors         1
          bDescriptorType        34 Report
          wDescriptorLength      78
         Report Descriptors: 
           ** UNAVAILABLE **
      Endpoint Descriptor:
        bLength                 7
        bDescriptorType         5
        bEndpointAddress     0x81  EP 1 IN
        bmAttributes            3
          Transfer Type            Interrupt
          Synch Type               None
          Usage Type               Data
        wMaxPacketSize     0x0008  1x 8 bytes
        bInterval               8
Device Status:     0x0000
  (Bus Powered)

'''
