#!/usr/bin/python
# coding: utf-8

import os, shutil

if os.geteuid() != 0:
    print "This program must be run as root. Aborting."
    os._exit(1)

srcPath = os.path.split(os.path.realpath(__file__))[0]

if not (os.path.exists('/dev/uinput')):
    print "Sorry. Your System Have Not /dev/uinput! Aborting."
    os._exit(1)

#install python-evdev
ret = os.system("apt-get install python-evdev")

#copy udev rules
systemctl = '/bin/systemctl'
destDir = '/etc/udev/rules.d/'
destFile = os.path.join(destDir, '99-wirelesspen.rules')
if os.path.exists(systemctl):
    srcFile = os.path.join(srcPath, '99-wirelesspen-systemd.rules')
else:
    srcFile = os.path.join(srcPath, '99-wirelesspen.rules')

if os.path.exists(srcFile):
    shutil.copy(srcFile, destFile)
else:
    print srcFile + "not Found. Aborting."
    os._exit(1)

# reload udev rules
ret = os.system("udevadm control --reload")

# creat systemd servies
if os.path.exists(systemctl):
    destFile = '/etc/systemd/system/wirelesspen.service'
    srcFile = os.path.join(srcPath, 'wirelesspen.service')
    if os.path.exists(srcFile):
        shutil.copy(srcFile, destFile)
    else:
        print srcFile + "not Found. Aborting."
        os._exit(1)
    # reload servies
    ret = os.system("systemctl daemon-reload")
else:
    # copy relay
    destFile = '/usr/bin/wirelesspen_relay.sh'
    srcFile = os.path.join(srcPath, 'wirelesspen_relay.sh')
    if os.path.exists(srcFile):
        shutil.copy(srcFile, destFile)
        # Run Permissions
        if os.path.exists(destFile):
            ret = os.system("chmod +x /usr/bin/wirelesspen_relay.sh")
        else:
            print destFile + "not Found. Aborting."
            os._exit(1)
    else:
        print srcFile + "not Found. Aborting."
        os._exit(1)



# copy wirelesspen.py
destFile = '/usr/bin/wirelesspen.py'
srcFile = os.path.join(srcPath, 'wirelesspen.py')
if os.path.exists(srcFile):
    shutil.copy(srcFile, destFile)
else:
    print srcFile + "not Found. Aborting."
    os._exit(1)

# Run Permissions
if os.path.exists(destFile):
    ret = os.system("chmod +x /usr/bin/wirelesspen.py")
else:
    print destFile + "not Found. Aborting."
    os._exit(1)







print "OK. Enjoy your presentation pen!"